/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.    
 */
package org.fabric3.scdl;

import java.net.URI;

import javax.xml.namespace.QName;

/**
 * The base representation of a binding specified in an assembly
 *
 * @version $Rev: 921 $ $Date: 2007-08-30 10:53:04 -0700 (Thu, 30 Aug 2007) $
 */
public abstract class BindingDefinition extends AbstractPolicyAware {
    
    private URI targetUri;
    private QName type;

    protected BindingDefinition(QName type) {
        this(null, type);
    }

    public BindingDefinition(URI targetUri, QName type) {
        this.targetUri = targetUri;
        this.type = type;
    }

    public URI getTargetUri() {
        return targetUri;
    }
    
    public QName getType() {
        return type;
    }
    
}
